<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { onMounted, ref, inject } from 'vue';
import { useRoute, useRouter } from 'vue-router';
import { storeToRefs } from 'pinia';
import { useI18n } from 'vue-i18n';
import { useMetaStore } from '@/stores/meta';
import { request } from '@/lib/request';
import Freeform from '@/components/freeform/Index.vue';
import Schedule from '@/components/schedule/Index.vue';
import Timeline from '@/components/timeline/Index.vue';
import { useBaseStore } from '@/stores/base';
import { notificationStatus } from '@/enums/enums';

const { t } = useI18n();
const $t = t; 

const route = useRoute();
const router = useRouter();
const baseStore = useBaseStore();
const { message, status } = storeToRefs(baseStore);
const metaStore = useMetaStore();
const { hashcode, noPassHash, adminMail, dashboard, paneType } = storeToRefs(metaStore);
const hasData = ref(false);
const boardType = ref(null);
const error = ref('');
let configuration = inject<any>('configuration');
const passwordlessID = ref();

onMounted(async()=>{
    if(route.params.id){
        error.value = '';
        passwordlessID.value = String(route.params.id);
        let response = await request('GET', configuration.apiServer + '/api/boarddata/passwordless/'+passwordlessID.value);
        if(!response || !response.success){
            message.value = $t('indexPage.error.notFound');
            status.value = notificationStatus.DANGER;
            router.push({name: "home"});
        }else{
            hashcode.value = response.hashcode;
            boardType.value = response.type;
            paneType.value = response.type;
            adminMail.value = response.adminMail;
            if(response.noPassHash)
                noPassHash.value = response.noPassHash;
            if(response.dashboard)
                dashboard.value = response.dashboard;
            hasData.value = true;
        }
    }else{
        message.value = $t('indexPage.error.notFound');
        status.value = notificationStatus.DANGER;
        router.push({name: "home"});
    }
});

</script>
<template>
    <div>
        <div v-if="hasData">
            <Freeform v-if="boardType === 'freeform' "/>
            <Schedule v-else-if="boardType === 'schedule' || boardType === 'stream'" />
            <Timeline v-else-if="boardType === 'timeline'" />
        </div>
    </div>
</template>